<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceAdditionalElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceAdditionalElement extends AbstractStructArrayBase
{
    /**
     * The ServiceSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceAdditionalElement[]
     */
    public $ServiceSupplement;
    /**
     * Constructor method for ArrayOfJP_ServiceAdditionalElement
     * @uses ArrayOfJP_ServiceAdditionalElement::setServiceSupplement()
     * @param \StructType\JP_ServiceAdditionalElement[] $serviceSupplement
     */
    public function __construct(array $serviceSupplement = array())
    {
        $this
            ->setServiceSupplement($serviceSupplement);
    }
    /**
     * Get ServiceSupplement value
     * @return \StructType\JP_ServiceAdditionalElement[]|null
     */
    public function getServiceSupplement()
    {
        return $this->ServiceSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceSupplementForArrayConstraintsFromSetServiceSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceAdditionalElementServiceSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceAdditionalElementServiceSupplementItem instanceof \StructType\JP_ServiceAdditionalElement) {
                $invalidValues[] = is_object($arrayOfJP_ServiceAdditionalElementServiceSupplementItem) ? get_class($arrayOfJP_ServiceAdditionalElementServiceSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceAdditionalElementServiceSupplementItem), var_export($arrayOfJP_ServiceAdditionalElementServiceSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceSupplement property can only contain items of type \StructType\JP_ServiceAdditionalElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceAdditionalElement[] $serviceSupplement
     * @return \ArrayType\ArrayOfJP_ServiceAdditionalElement
     */
    public function setServiceSupplement(array $serviceSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceSupplementArrayErrorMessage = self::validateServiceSupplementForArrayConstraintsFromSetServiceSupplement($serviceSupplement))) {
            throw new \InvalidArgumentException($serviceSupplementArrayErrorMessage, __LINE__);
        }
        $this->ServiceSupplement = $serviceSupplement;
        return $this;
    }
    /**
     * Add item to ServiceSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_ServiceAdditionalElement
     */
    public function addToServiceSupplement(\StructType\JP_ServiceAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The ServiceSupplement property can only contain items of type \StructType\JP_ServiceAdditionalElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceSupplement
     */
    public function getAttributeName()
    {
        return 'ServiceSupplement';
    }
}
